this.name           = "neoDockLights_worldScript.js";
this.author         = "Thargoid";
this.copyright      = "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description    = "World script for the new dock lights OXP";
this.version        = "0.10";
"use strict";

this.shipWillLaunchFromStation = function(station)
	{ if(station.isMainStation) { this.shipEnteredStationAegis(); } }	
	
this.shipWillDockWithStation = function(station)
	{ if(station.isMainStation) { this.shipDied(); } }	

this.shipEnteredStationAegis = function()
	{
	if(system.isInterstellarSpace || !system.mainStation || !system.mainStation.isValid || system.techLevel < 2)
		{ return; }
	
	this.lightsPosition = system.mainStation.position.add(system.mainStation.vectorForward.multiply(10000));
	this.lights = system.addVisualEffect("dockLights_green", this.lightsPosition);
	this.lights.orientation = system.mainStation.orientation;
	this.lightsStatus = "GREEN";
	
	this.lightsTimer = new Timer(this, this.setLights, 0, 0.25);
	}

this.setLights = function()
	{
	if(!system.mainStation) 
		{
		this.shipDied();
		return; 
		}
	
	function dockingShips(entity) {return entity.isShip && !entity.hasRole("buoy") && ((entity.position.distanceTo(system.mainStation.position) + entity.position.distanceTo(this.lights.position)) < 10100)}
	var incomingArray = system.filteredEntities(this, dockingShips, system.mainStation, 10000);

	this.lightsPosition = system.mainStation.position.add(system.mainStation.vectorForward.multiply(10000));
	
	if(incomingArray.length > 0 && this.lightsStatus === "GREEN")
		{ 
		this.removeLights();
		this.lights = system.addVisualEffect("dockLights_red", this.lightsPosition);	
		this.lights.orientation = system.mainStation.orientation;
		this.lightsStatus = "RED";		
		return;
		}
		
	if(incomingArray.length === 0 && this.lightsStatus === "RED")
		{ 
		this.removeLights();
		this.lights = system.addVisualEffect("dockLights_green", this.lightsPosition);
		this.lights.orientation = system.mainStation.orientation;
		this.lightsStatus = "GREEN";
		return;
		}
	}
	
this.shipDied = this.shipWillEnterWitchspace =  this.shipExitedStationAegis = function()
	{
	this.removeLights();
	if(this.lightsTimer) 
		{
		this.lightsTimer.stop();
		delete this.lightsTimer;
		}
	}	
	
this.removeLights = function()
	{
	var count = system.allVisualEffects.length;
	if(count === 0) { return; }
	for (var i=count-1; i>=0; i--)
		{
		if(system.allVisualEffects[i].dataKey === "dockLights_green" || system.allVisualEffects[i].dataKey === "dockLights_red")
			{ system.allVisualEffects[i].remove(); }
		}
	}
	